function CMF3D_MIND_symmetric_ind(FD_lung, FD_lung_out, FD_lung_reg, ref)

    img = double(metaImageRead(FD_lung));
    hdr = metaImageInfo(FD_lung);
    hdr.ElementType = 'MET_FLOAT';
    
    mask = double(metaImageRead(FD_lung_out));
    mask(mask == 3) = 0;
    
    mask_tem = zeros(size(mask));
    mask_tem(:,1:size(mask)/2,:) = 1;
    mask_tem(:,size(mask)/2+1:end,:) = 2;
    mask = (mask==1|mask==2).*mask_tem;
    
    h_rows = hdr.DimSize(1);
    h_cols = hdr.DimSize(2);
    h_slices = hdr.DimSize(3);
    [rows,cols,slices] = size(img);
    
    if(h_rows~=rows || h_cols~=cols || h_slices~=slices)
        display('Unequal image dimensons! Exit....');
        return;
    end
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% extracting the right lung %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
    img_right = img(:, 1:round(end/2), :);
    mask_right = mask(:, 1:round(end/2), :);
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% extracting the left lung %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    img_left = img(:, round(end/2)+1:end, :);
    mask_left = mask(:, round(end/2)+1:end, :);
        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% We register a subset (50 at a time) of the full image series to%
%%%%%%%%%%%%%%%%%achieve high computatonal efficiency%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    num_slices = 50;
    num_repetitions = ceil(slices/num_slices);
    tic
    for i = 1 : num_repetitions
        % left and right individual lung registration
        right_lung_def(:,:,(i-1)*num_slices+1:min(i*num_slices,slices)) = CMF_MIND_symmetric(img_right(:,:,(i-1)*num_slices+1:min(i*num_slices,slices)),mask_right(:,:,(i-1)*num_slices+1:min(i*num_slices,slices)),img_right(:,:,ref),mask_right(:,:,ref));
        left_lung_def(:,:,(i-1)*num_slices+1:min(i*num_slices,slices)) = CMF_MIND_symmetric(img_left(:,:,(i-1)*num_slices+1:min(i*num_slices,slices)),mask_left(:,:,(i-1)*num_slices+1:min(i*num_slices,slices)),img_left(:,:,ref),mask_left(:,:,ref));
        display(['Registration progress: ' num2str(i) ' out of ' num2str(num_repetitions) ' !\n']);
    end
    lung_def = zeros(rows, cols, slices);
    lung_def(:, 1:round(end/2), :) = right_lung_def;
    lung_def(:, round(end/2)+1:end, :) = left_lung_def;
    time = toc
    display(['Free-breathing H MRI lung series registration took ' num2str(time) 'seconds!']);
    % save the registration results;
    metaImageWrite(lung_def, FD_lung_reg, hdr);
end