function FD_lung_def = CMF_MIND_symmetric(FD_lung, FD_lung_mask, ref_img, ref_mask)

num_slices = size(FD_lung,3);
img1 = repmat(ref_img, [1 1 num_slices]);
img2 = FD_lung;

img1_orig = img1;
img1 = mat2gray(img1)*200;

img2_orig = img2;
for s = 1 : num_slices
    img2(:,:,s) = mat2gray(img2(:,:,s));
end
img2 = img2*200;


numIter = 300;
steps = 0.12; 
alpha = 0.02;
cc = 0.2;

Ux1 = zeros(2, 2, num_slices,'single'); 
Uy1 = Ux1; 
Ux2 = zeros(2, 2, num_slices,'single'); 
Uy2 = Ux2; 

wi = 0.6;
errbound = 1e-6;
warps  = [8,4,2,1]*2;
levels = [8,4,2,1];
sig = 0.8;

for j = 1:length(levels)
    
    hs = fspecial('gaussian',[1,8],max(levels(j)/4, 0.8));
    
    for s = 1 : num_slices
        tem_img1_l(:,:,s) = imresize(volfilter(img1(:,:,s),hs), ceil([size(img1,1) size(img1,2)]./levels(j)),'antialiasing',false);
        tem_img2_l(:,:,s) = imresize(volfilter(img2(:,:,s),hs), ceil([size(img2,1) size(img2,2)]./levels(j)),'antialiasing',false);
    
        [tem_Ux1(:,:,s), tem_Uy1(:,:,s)] = resizeFlow2d(Ux1(:,:,s), Uy1(:,:,s), [size(tem_img1_l,1) size(tem_img1_l,2)]);
    
        ux1 = zeros([ceil([size(img1,1) size(img1,2)]./levels(j)) num_slices]);
        uy1 = zeros([ceil([size(img1,1) size(img1,2)]./levels(j)) num_slices]);
        uz1 = 0;
        
        [tem_Ux2(:,:,s), tem_Uy2(:,:,s)] = resizeFlow2d(Ux2(:,:,s), Uy2(:,:,s), [size(tem_img1_l,1) size(tem_img1_l,2)]);
    
        ux2 = zeros([ceil([size(img1,1) size(img1,2)]./levels(j)) num_slices]);
        uy2 = zeros([ceil([size(img1,1) size(img1,2)]./levels(j)) num_slices]);
        uz2 = 0;
    end
    
    img1_l = tem_img1_l;
    img2_l = tem_img2_l;
    
    clear tem_img1_l tem_img2_l;
    
    Ux1 = tem_Ux1;
    Uy1 = tem_Uy1;
    Uz1 = 0;
    
    Ux2 = tem_Ux2;
    Uy2 = tem_Uy2;
    Uz2 = 0;
    
    clear tem_Ux1 tem_Uy1 tem_Ux2 tem_Uy2;
    
    [n_rows,n_cols,n_heights] = size(img1_l);
    
    for k = 1:warps(j)
        
        Ux1 = Ux1 + ux1*wi;
        Uy1 = Uy1 + uy1*wi;      
        Uz1 = 0; 
        
%         img1_w = img1_l;
        for s = 1: num_slices
            tem_img2_w(:,:,s) = imWarp2d(Ux1(:,:,s), Uy1(:,:,s), img2_l(:,:,s), 'cubic');

            tem_ssc_q1(:,:,s,:) = MIND_descriptor2D(img1_l(:,:,s), 1, sig);
            tem_ssc_q2(:,:,s,:) = MIND_descriptor2D(tem_img2_w(:,:,s), 1, sig);
        end
%         img2_w = tem_img2_w;
        ssc_q1 = tem_ssc_q1;
        ssc_q2 = tem_ssc_q2;
        
        clear tem_img2_w;
        clear tem_ssc_q1 tem_ssc_q2;

        gt1 = mean(abs(ssc_q2 - ssc_q1), 4);
        
        gx1 = mean(abs([ssc_q2(:,2:n_cols,:,:), ssc_q2(:,n_cols,:,:)] - ssc_q1), 4) - mean(abs([ssc_q2(:,1,:,:),ssc_q2(:,1:n_cols-1,:,:)] - ssc_q1), 4);
        gy1 = mean(abs([ssc_q2(2:n_rows,:,:,:); ssc_q2(n_rows,:,:,:)] - ssc_q1), 4) - mean(abs([ssc_q2(1,:,:,:);ssc_q2(1:n_rows-1,:,:,:)] - ssc_q1), 4);
        gz1 = 0;
        gx1 = gx1./2;
        gy1 = gy1./2;
        gf1 = gx1.*gx1 + gy1.*gy1;
        
        
        Ux2 = Ux2 + ux2*wi;
        Uy2 = Uy2 + uy2*wi;      
        Uz2 = 0; 
        
%         img2_w = img2_l;
        for s = 1: num_slices
            tem_img1_w(:,:,s) = imWarp2d(Ux2(:,:,s), Uy2(:,:,s), img1_l(:,:,s), 'cubic');

            tem_ssc_q2(:,:,s,:) = MIND_descriptor2D(img2_l(:,:,s), 1, sig);
            tem_ssc_q1(:,:,s,:) = MIND_descriptor2D(tem_img1_w(:,:,s), 1, sig);
        end
%         img1_w = tem_img1_w;
        ssc_q1 = tem_ssc_q1;
        ssc_q2 = tem_ssc_q2;
        
        clear tem_img1_w;
        clear tem_ssc_q1 tem_ssc_q2;
        
        gt2 = mean(abs(ssc_q1 - ssc_q2), 4);
        
        gx2 = mean(abs([ssc_q1(:,2:n_cols,:,:), ssc_q1(:,n_cols,:,:)] - ssc_q2), 4) - mean(abs([ssc_q1(:,1,:,:),ssc_q1(:,1:n_cols-1,:,:)] - ssc_q2), 4);
        gy2 = mean(abs([ssc_q1(2:n_rows,:,:,:); ssc_q1(n_rows,:,:,:)] - ssc_q2), 4) - mean(abs([ssc_q1(1,:,:,:);ssc_q1(1:n_rows-1,:,:,:)] - ssc_q2), 4);
        gz2 = 0;
        gx2 = gx2./2;
        gy2 = gy2./2;
        gf2 = gx2.*gx2 + gy2.*gy2;
        % - para: a sequence of parameters for the algorithm
        %   para[0,1,2]: rows, cols, heights of the given image
        %   para[3]: the maximum iteration number
        %   para[4]: the error bound for convergence
        %   para[5]: cc for the step-size of augmented Lagrangian method
        %   para[6]: the step-size for the graident-projection step to the
        %   total-variation function.
        varaParas = [n_rows; n_cols; n_heights; levels(j)*numIter; errbound; cc; steps; alpha];
        
        % CPU based flow adpating
%         [ux, uy, uz, err, num, timet] = CMF3D_TVL1_Newton_mex(single(varaParas), single(Ux), single(Uy), single(Uz), single(gx), single(gy), single(gz), single(gt), single(gf));
        % GPU based flow adpating
        [ux1, uy1, uz1, err, num, timet] = CMF3D_TVL1_Newton_GPU_opt(single(varaParas), single(Ux1), single(Uy1), single(Uz1), single(gx1), single(gy1), single(gz1), single(gt1), single(gf1));
        [ux2, uy2, uz2, err, num, timet] = CMF3D_TVL1_Newton_GPU_opt(single(varaParas), single(Ux2), single(Uy2), single(Uz2), single(gx2), single(gy2), single(gz2), single(gt2), single(gf2));
        for s = 1 : num_slices
            [ux1(:,:,s), uy1(:,:,s), ux2(:,:,s), uy2(:,:,s)] = symmetricMapping2d(ux1(:,:,s), uy1(:,:,s), ux2(:,:,s), uy2(:,:,s));
        end
    end
    %     % testing
    %     out_vol = volWarp(g2q,Ux,Uy,Uz);
    %     slice=uint16(size(out_vol,3)/2);
    %     figure();
    %     subplot(2,3,1); imshow(g1q(:,:,slice),[]); title('g1q')
    %     subplot(2,3,2); imshow(g2q(:,:,slice),[]); title('g2q')
    %     subplot(2,3,3); imshow(out_vol(:,:,slice),[]); title('g2q_w')
    %     subplot(2,3,4); imshow(abs(g1q(:,:,slice)-out_vol(:,:,slice)),[]); title('abs(g1q-g2q_w)')
    %     subplot(2,3,5); quiver(Uy(:,:,slice),Ux(:,:,slice)); axis('equal'); title('Uy,Ux')
    %     tmp = zeros([size(g1q(:,:,slice)),3]);
    %     tmp(:,:,1) = mat2gray(Uy(:,:,slice)); tmp(:,:,2) = mat2gray(Ux(:,:,slice)); tmp(:,:,3) = mat2gray(Uz(:,:,slice));
    %     subplot(2,3,6); imshow(tmp);
        Ux1 = Ux1 + ux1*wi;
        Uy1 = Uy1 + uy1*wi;      
        Uz1 = 0; 
        
        Ux2 = Ux2 + ux2*wi;
        Uy2 = Uy2 + uy2*wi;      
        Uz2 = 0; 
end

if(levels(end)>1)
    for s = 1 : num_slices
        [tem_Ux1(:,:,s), tem_Uy1(:,:,s)] = resizeFlow2d(Ux1(:,:,s),Uy1(:,:,s),[size(img1,1) size(img1,2)]);
    end
end

Ux1 = tem_Ux1;
Uy1 = tem_Uy1;
clear tem_Ux1 tem_Uy1;
% deform the images;
for s = 1 : num_slices
    img2_orig_def(:,:,s) = imWarp2d(Ux1(:,:,s), Uy1(:,:,s), img2_orig(:,:,s), 'cubic');
end

FD_lung_def = img2_orig_def;
end
